/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.appkit.NSImageView;

import dstep.appkit.NSControl;
import dstep.appkit.NSImage;
import dstep.appkit.NSImageCell;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

class NSImageView : NSControl
{
	mixin ObjcWrap;
	
	this (id object)
	{
		super(object);
	}

	NSImage image ()
	{
		return invokeObjcSelf!(NSImage, "image");
	}

	void setImage (NSImage newImage)
	{
		return invokeObjcSelf!(void, "setImage:", NSImage)(newImage);
	}

	uint imageAlignment ()
	{
		return invokeObjcSelf!(uint, "imageAlignment");
	}

	void setImageAlignment (uint newAlign)
	{
		return invokeObjcSelf!(void, "setImageAlignment:", uint)(newAlign);
	}

	uint imageScaling ()
	{
		return invokeObjcSelf!(uint, "imageScaling");
	}

	void setImageScaling (uint newScaling)
	{
		return invokeObjcSelf!(void, "setImageScaling:", uint)(newScaling);
	}

	uint imageFrameStyle ()
	{
		return invokeObjcSelf!(uint, "imageFrameStyle");
	}

	void setImageFrameStyle (uint newStyle)
	{
		return invokeObjcSelf!(void, "setImageFrameStyle:", uint)(newStyle);
	}

	void setEditable (bool yn)
	{
		return invokeObjcSelf!(void, "setEditable:", bool)(yn);
	}

	bool isEditable ()
	{
		return invokeObjcSelf!(bool, "isEditable");
	}

	void setAnimates (bool flag)
	{
		return invokeObjcSelf!(void, "setAnimates:", bool)(flag);
	}

	bool animates ()
	{
		return invokeObjcSelf!(bool, "animates");
	}

	bool allowsCutCopyPaste ()
	{
		return invokeObjcSelf!(bool, "allowsCutCopyPaste");
	}

	void setAllowsCutCopyPaste (bool allow)
	{
		return invokeObjcSelf!(void, "setAllowsCutCopyPaste:", bool)(allow);
	}
}

