/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.appkit.NSScreen;

import dstep.appkit.NSGraphics;
import dstep.applicationservices.coregraphics.CGBase;
import dstep.foundation.NSArray;
import dstep.foundation.NSDictionary;
import dstep.foundation.NSGeometry;
import dstep.foundation.NSObject;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

struct NSScreenAuxiliary;

alias NSScreenAuxiliary NSScreenAuxiliaryOpaque;

class NSScreen : NSObject
{
	mixin ObjcWrap;
	
	this (id object)
	{
		super(object);
	}

	static NSArray screens ()
	{
		return invokeObjcSelfClass!(NSArray, "screens");
	}

	static NSScreen mainScreen ()
	{
		return invokeObjcSelfClass!(NSScreen, "mainScreen");
	}

	static NSScreen deepestScreen ()
	{
		return invokeObjcSelfClass!(NSScreen, "deepestScreen");
	}

	int depth ()
	{
		return invokeObjcSelf!(int, "depth");
	}

	NSRect frame ()
	{
		return invokeObjcSelf!(NSRect, "frame");
	}

	NSRect visibleFrame ()
	{
		return invokeObjcSelf!(NSRect, "visibleFrame");
	}

	NSDictionary deviceDescription ()
	{
		return invokeObjcSelf!(NSDictionary, "deviceDescription");
	}

	NSWindowDepth* supportedWindowDepths ()
	{
		return invokeObjcSelf!(NSWindowDepth*, "supportedWindowDepths");
	}

	CGFloat userSpaceScaleFactor ()
	{
		return invokeObjcSelf!(CGFloat, "userSpaceScaleFactor");
	}
}

