/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.appkit.NSSearchFieldCell;

import dstep.appkit.NSButtonCell;
import dstep.appkit.NSMenu;
import dstep.appkit.NSTextFieldCell;
import dstep.foundation.NSArray;
import dstep.foundation.NSGeometry;
import dstep.foundation.NSObjCRuntime;
import dstep.foundation.NSString;
import dstep.foundation.NSTimer;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

class NSSearchFieldCell : NSTextFieldCell
{
	mixin ObjcWrap;
	
	this (id object)
	{
		super(object);
	}

	NSButtonCell searchButtonCell ()
	{
		return invokeObjcSelf!(NSButtonCell, "searchButtonCell");
	}

	void setSearchButtonCell (NSButtonCell cell)
	{
		return invokeObjcSelf!(void, "setSearchButtonCell:", NSButtonCell)(cell);
	}

	NSButtonCell cancelButtonCell ()
	{
		return invokeObjcSelf!(NSButtonCell, "cancelButtonCell");
	}

	void setCancelButtonCell (NSButtonCell cell)
	{
		return invokeObjcSelf!(void, "setCancelButtonCell:", NSButtonCell)(cell);
	}

	void resetSearchButtonCell ()
	{
		return invokeObjcSelf!(void, "resetSearchButtonCell");
	}

	void resetCancelButtonCell ()
	{
		return invokeObjcSelf!(void, "resetCancelButtonCell");
	}

	NSRect searchTextRectForBounds (NSRect rect)
	{
		return invokeObjcSelf!(NSRect, "searchTextRectForBounds:", NSRect)(rect);
	}

	NSRect searchButtonRectForBounds (NSRect rect)
	{
		return invokeObjcSelf!(NSRect, "searchButtonRectForBounds:", NSRect)(rect);
	}

	NSRect cancelButtonRectForBounds (NSRect rect)
	{
		return invokeObjcSelf!(NSRect, "cancelButtonRectForBounds:", NSRect)(rect);
	}

	void setSearchMenuTemplate (NSMenu menu)
	{
		return invokeObjcSelf!(void, "setSearchMenuTemplate:", NSMenu)(menu);
	}

	NSMenu searchMenuTemplate ()
	{
		return invokeObjcSelf!(NSMenu, "searchMenuTemplate");
	}

	void setSendsWholeSearchString (bool flag)
	{
		return invokeObjcSelf!(void, "setSendsWholeSearchString:", bool)(flag);
	}

	bool sendsWholeSearchString ()
	{
		return invokeObjcSelf!(bool, "sendsWholeSearchString");
	}

	void setMaximumRecents (NSInteger maxRecents)
	{
		return invokeObjcSelf!(void, "setMaximumRecents:", NSInteger)(maxRecents);
	}

	NSInteger maximumRecents ()
	{
		return invokeObjcSelf!(NSInteger, "maximumRecents");
	}

	void setRecentSearches (NSArray searches)
	{
		return invokeObjcSelf!(void, "setRecentSearches:", NSArray)(searches);
	}

	NSArray recentSearches ()
	{
		return invokeObjcSelf!(NSArray, "recentSearches");
	}

	void setRecentsAutosaveName (NSString string)
	{
		return invokeObjcSelf!(void, "setRecentsAutosaveName:", NSString)(string);
	}

	NSString recentsAutosaveName ()
	{
		return invokeObjcSelf!(NSString, "recentsAutosaveName");
	}

	bool sendsSearchStringImmediately ()
	{
		return invokeObjcSelf!(bool, "sendsSearchStringImmediately");
	}

	void setSendsSearchStringImmediately (bool flag)
	{
		return invokeObjcSelf!(void, "setSendsSearchStringImmediately:", bool)(flag);
	}
}

