/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.appkit.NSStringDrawing;

import dstep.appkit.NSAttributedString;
import dstep.foundation.NSObjCRuntime;
import dstep.foundation.NSString;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

typedef NSInteger NSStringDrawingOptions;

enum : NSInteger
{
	NSStringDrawingTruncatesLastVisibleLine = (1 << 5),
	NSStringDrawingUsesLineFragmentOrigin = (1 << 0),
	NSStringDrawingUsesFontLeading = (1 << 1),
	NSStringDrawingDisableScreenFontSubstitution = (1 << 2),
	NSStringDrawingUsesDeviceMetrics = (1 << 3),
	NSStringDrawingOneShot = (1 << 4)
}

const TNSStringDrawing = `

	NSSize size ()
	{
		return invokeObjcSelf!(NSSize, "size");
	}

	void drawAtPoint (NSPoint point)
	{
		return invokeObjcSelf!(void, "drawAtPoint:", NSPoint)(point);
	}

	void drawInRect (NSRect rect)
	{
		return invokeObjcSelf!(void, "drawInRect:", NSRect)(rect);
	}

	//mixin ObjcBindMethod!(size, "size");
	//mixin ObjcBindMethod!(drawAtPoint, "drawAtPoint:");
	//mixin ObjcBindMethod!(drawInRect, "drawInRect:");

`;

const TNSExtendedStringDrawing = `

	void drawWithRect (NSRect rect, int options, NSDictionary attributes)
	{
		return invokeObjcSelf!(void, "drawWithRect:options:attributes:", NSRect, int, NSDictionary)(rect, options, attributes);
	}

	NSRect boundingRectWithSize (NSSize size, int options, NSDictionary attributes)
	{
		return invokeObjcSelf!(NSRect, "boundingRectWithSize:options:attributes:", NSSize, int, NSDictionary)(size, options, attributes);
	}

	//mixin ObjcBindMethod!(drawWithRect, "drawWithRect:options:attributes:");
	//mixin ObjcBindMethod!(boundingRectWithSize, "boundingRectWithSize:options:attributes:");

`;

