/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.appkit.NSTableHeaderCell;

import dstep.appkit.NSTextFieldCell;
import dstep.appkit.NSView;
import dstep.foundation.NSGeometry;
import dstep.foundation.NSObjCRuntime;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

class NSTableHeaderCell : NSTextFieldCell
{
	mixin ObjcWrap;
	
	this (id object)
	{
		super(object);
	}

	void drawSortIndicatorWithFrame (NSRect cellFrame, NSView controlView, bool ascending, NSInteger priority)
	{
		return invokeObjcSelf!(void, "drawSortIndicatorWithFrame:inView:ascending:priority:", NSRect, NSView, bool, NSInteger)(cellFrame, controlView, ascending, priority);
	}

	NSRect sortIndicatorRectForBounds (NSRect theRect)
	{
		return invokeObjcSelf!(NSRect, "sortIndicatorRectForBounds:", NSRect)(theRect);
	}
}

