/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 25, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.coredata.NSPropertyDescription;

import dstep.coredata.NSEntityDescription;
import dstep.foundation.NSArray;
import dstep.foundation.NSCoder;
import dstep.foundation.NSData;
import dstep.foundation.NSDictionary;
import dstep.foundation.NSObject;
import dstep.foundation.NSString;
import dstep.foundation.NSZone;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

class NSPropertyDescription : NSObject, INSCoding, INSCopying
{
	mixin ObjcWrap;
	
	this (id object)
	{
		super(object);
	}

	NSEntityDescription entity ()
	{
		return invokeObjcSelf!(NSEntityDescription, "entity");
	}

	NSString name ()
	{
		return invokeObjcSelf!(NSString, "name");
	}

	void setName (NSString name)
	{
		return invokeObjcSelf!(void, "setName:", NSString)(name);
	}

	bool isOptional ()
	{
		return invokeObjcSelf!(bool, "isOptional");
	}

	void setOptional (bool flag)
	{
		return invokeObjcSelf!(void, "setOptional:", bool)(flag);
	}

	bool isTransient ()
	{
		return invokeObjcSelf!(bool, "isTransient");
	}

	void setTransient (bool flag)
	{
		return invokeObjcSelf!(void, "setTransient:", bool)(flag);
	}

	NSArray validationPredicates ()
	{
		return invokeObjcSelf!(NSArray, "validationPredicates");
	}

	NSArray validationWarnings ()
	{
		return invokeObjcSelf!(NSArray, "validationWarnings");
	}

	void setValidationPredicates (NSArray validationPredicates, NSArray validationWarnings)
	{
		return invokeObjcSelf!(void, "setValidationPredicates:withValidationWarnings:", NSArray, NSArray)(validationPredicates, validationWarnings);
	}

	NSDictionary userInfo ()
	{
		return invokeObjcSelf!(NSDictionary, "userInfo");
	}

	void setUserInfo (NSDictionary dictionary)
	{
		return invokeObjcSelf!(void, "setUserInfo:", NSDictionary)(dictionary);
	}

	bool isIndexed ()
	{
		return invokeObjcSelf!(bool, "isIndexed");
	}

	void setIndexed (bool flag)
	{
		return invokeObjcSelf!(void, "setIndexed:", bool)(flag);
	}

	NSData versionHash ()
	{
		return invokeObjcSelf!(NSData, "versionHash");
	}

	NSString versionHashModifier ()
	{
		return invokeObjcSelf!(NSString, "versionHashModifier");
	}

	void setVersionHashModifier (NSString modifierString)
	{
		return invokeObjcSelf!(void, "setVersionHashModifier:", NSString)(modifierString);
	}

	void encodeWithCoder (NSCoder aCoder)
	{
		return invokeObjcSelf!(void, "encodeWithCoder:", NSCoder)(aCoder);
	}
	
	typeof(this) initWithCoder (NSCoder aDecoder)
	{
		return invokeObjcSelf!(typeof(this), "initWithCoder:", NSCoder)(aDecoder);
	}
	
	typeof(this) copyWithZone (NSZone* zone)
	{
		return invokeObjcSelf!(typeof(this), "copyWithZone:", NSZone*)(zone);
	}
}

