/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Jul 21, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.coreservices.carboncore.DriverServices;

//import dstep.AvailabilityMacros;
import dstep.coreservices.carboncore.ConditionalMacros;
import dstep.coreservices.carboncore.DriverSynchronization;
import dstep.coreservices.carboncore.MacErrors;
import dstep.coreservices.carboncore.MacTypes;
import dstep.coreservices.carboncore.MachineExceptions;

alias UnsignedWide Nanoseconds;

enum
{
	durationMicrosecond = -1L,
	durationMillisecond = 1L,
	durationSecond = 1000L,
	durationMinute = 60000L,
	durationHour = 3600000L,
	durationDay = 86400000L,
	durationNoWait = 0L,
	durationForever = 0x7FFFFFFF
}

extern (C)
{
	AbsoluteTime UpTime ();
	Nanoseconds AbsoluteToNanoseconds (AbsoluteTime absoluteTime);
	int AbsoluteToDuration (AbsoluteTime absoluteTime);
	AbsoluteTime NanosecondsToAbsolute (Nanoseconds nanoseconds);
	AbsoluteTime DurationToAbsolute (int duration);
	AbsoluteTime AddAbsoluteToAbsolute (AbsoluteTime absoluteTime1, AbsoluteTime absoluteTime2);
	AbsoluteTime SubAbsoluteFromAbsolute (AbsoluteTime leftAbsoluteTime, AbsoluteTime rightAbsoluteTime);
	AbsoluteTime AddNanosecondsToAbsolute (Nanoseconds nanoseconds, AbsoluteTime absoluteTime);
	AbsoluteTime AddDurationToAbsolute (int duration, AbsoluteTime absoluteTime);
	AbsoluteTime SubNanosecondsFromAbsolute (Nanoseconds nanoseconds, AbsoluteTime absoluteTime);
	AbsoluteTime SubDurationFromAbsolute (int duration, AbsoluteTime absoluteTime);
	Nanoseconds AbsoluteDeltaToNanoseconds (AbsoluteTime leftAbsoluteTime, AbsoluteTime rightAbsoluteTime);
	int AbsoluteDeltaToDuration (AbsoluteTime leftAbsoluteTime, AbsoluteTime rightAbsoluteTime);
	Nanoseconds DurationToNanoseconds (int theDuration);
	int NanosecondsToDuration (Nanoseconds theNanoseconds);
}