/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 3, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.foundation.NSProtocolChecker;

import dstep.foundation.NSObject;
import dstep.foundation.NSProxy;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;


import dstep.objc.runtime;

const TNSProtocolCheckerCreation = `

	static Object protocolCheckerWithTarget (NSObject anObject, Protocol aProtocol)
	{
		return invokeObjcSuperClass!(Object, "protocolCheckerWithTarget:protocol:", NSObject, Protocol)(anObject, aProtocol);
	}

	Object initWithTarget (NSObject anObject, Protocol aProtocol)
	{
		return invokeObjcSelf!(Object, "initWithTarget:protocol:", NSObject, Protocol)(anObject, aProtocol);
	}

	this (NSObject anObject, Protocol aProtocol)
	{
		typeof(this).alloc.initWithTarget(anObject, aProtocol);
	}
`;

class NSProtocolChecker : NSProxy
{
	mixin ObjcWrap;
	
	this (id object)
	{
		super(object);
	}
	
	this ()
	{
		super(typeof(this).alloc.init.objcObject);
	}
	
	typeof(this) init ()
	{
		return invokeObjcSelf!(typeof(this), "init");
	}

	Protocol protocol ()
	{
		return invokeObjcSelf!(Protocol, "protocol");
	}

	NSObject target ()
	{
		return invokeObjcSelf!(NSObject, "target");
	}
	
	// TNSProtocolCheckerCreation
	static Object protocolCheckerWithTarget (NSObject anObject, Protocol aProtocol)
	{
		return invokeObjcSuperClass!(Object, "protocolCheckerWithTarget:protocol:", NSObject, Protocol)(anObject, aProtocol);
	}
	
	Object initWithTarget (NSObject anObject, Protocol aProtocol)
	{
		return invokeObjcSelf!(Object, "initWithTarget:protocol:", NSObject, Protocol)(anObject, aProtocol);
	}
	
	this (NSObject anObject, Protocol aProtocol)
	{
		typeof(this).alloc.initWithTarget(anObject, aProtocol);
	}
}