/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.opengl.gliDispatch;

import dstep.opengl.gl;
import dstep.opengl.glext;
import dstep.opengl.gliContext;

struct GLIFunctionDispatch
{
	uint op;
	uint func;
	int n;
	GLuint* textures;
	uint target;
	int width;
	int height;
	float xorig;
	float yorig;
	float xmove;
	float ymove;
	uint sfactor;
	uint type;
	float red;
	float green;
	float blue;
	uint plane;
	uint face;
	int size;
	int stride;
	int x;
	int y;
	int level;
	uint internalFormat;
	int xoffset;
	int yoffset;
	uint list;
	double zNear;
	uint mode;
	int first;
	int count;
	uint format;
	double u;
	int i1;
	int i2;
	int j1;
	int i;
	uint pname;
	double left;
	double right;
	double bottom;
	double top;
	uint light;
	uint query;
	uint map;
	uint coord;
	int factor;
	double u1;
	double u2;
	int order;
	int ustride;
	int uorder;
	double v1;
	double v2;
	int vstride;
	int vorder;
	int un;
	int vn;
	byte nx;
	byte ny;
	int mapsize;
	float xfactor;
	double z;
	double x1;
	double y1;
	double x2;
	double angle;
	int ref_;
	uint fail;
	uint zfail;
	double s;
	double t;
	double r;
	uint internalformat;
	int border;
	uint sfactorRGB;
	uint dfactorRGB;
	uint sfactorAlpha;
	int depth;
	int imageSize;
	int zoffset;
	uint start;
	uint end;
	GLvoid* row;
	GLvoid* column;
	ubyte reset;
	uint stage;
	uint portion;
	uint variable;
	uint input;
	uint mapping;
	uint abOutput;
	uint cdOutput;
	uint sumOutput;
	uint scale;
	uint bias;
	ubyte abDotProduct;
	ubyte cdDotProduct;
	int length;
	uint equationRGB;
	float value;
	uint object;
	uint index;
	ubyte normalized;
	int len;
	GLvoid** indices;
	uint sfail;
	uint dpfail;
	uint frontfunc;
	uint backfunc;
	GLhandleARB containerObj;
	GLhandleARB shaderObj;
	GLcharARB** string;
	int location;
	float v0;
	ubyte transpose;
	GLhandleARB obj;
	int maxLength;
	int maxCount;
	GLhandleARB programObj;
	uint id;
	GLvoid* data;
	int offset;
	double zmin;
	uint shader;
	uint program;
	int bufSize;
	uint attachment;
	uint textarget;
	uint texture;
	uint renderbuffertarget;
	uint objectType;
	uint name;
	uint program_name;
	uint buffer;
	GLchar** varyings;
	uint param;
	int g;
	int b;
	uint colorNumber;
	GLuint* shaders;
	uint binaryformat;
	GLvoid* binary;
	uint shadertype;
	uint precisiontype;
	GLint* range;
	GLint* listofformats;
	int srcX0;
	int srcY0;
	int srcX1;
	int srcY1;
	int dstX0;
	int dstY0;
	int dstX1;
	int dstY1;
	uint mask;
	int samples;
}

