/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.quartzcore.CIKernel;

import dstep.foundation.NSArray;
import dstep.foundation.NSObject;
import dstep.foundation.NSString;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;
import dstep.quartzcore.CIImage;

class CIKernel : NSObject
{
	mixin ObjcWrap;
	
	this (id object)
	{
		super(object);
	}

	static NSArray kernelsWithString (NSString s)
	{
		return invokeObjcSelfClass!(NSArray, "kernelsWithString:", NSString)(s);
	}

	NSString name ()
	{
		return invokeObjcSelf!(NSString, "name");
	}

	void setROISelector (SEL aMethod)
	{
		return invokeObjcSelf!(void, "setROISelector:", SEL)(aMethod);
	}
}

